OpenSSLClient Class Reference

`#include <tlsopensslclient.h>`

Inheritance diagram for OpenSSLClient:
[legend]

## Public Member Functions

| OpenSSLClient (TLSHandler *th, const std::string &server)
virtual | ~OpenSSLClient ()
virtual bool | hasChannelBinding () const
virtual const std::string | channelBinding () const
virtual const std::string | channelBindingType () const
Public Member Functions inherited from OpenSSLBase
| OpenSSLBase (TLSHandler *th, const std::string &server=EmptyString)
virtual | ~OpenSSLBase ()
virtual bool | init (const std::string &clientKey=EmptyString, const std::string &clientCerts=EmptyString, const StringList &cacerts=StringList())
virtual bool | encrypt (const std::string &data)
virtual int | decrypt (const std::string &data)
virtual void | cleanup ()
virtual bool | handshake ()
virtual void | setCACerts (const StringList &cacerts)
virtual void | setClientCert (const std::string &clientKey, const std::string &clientCerts)
Public Member Functions inherited from TLSBase
| TLSBase (TLSHandler *th, const std::string server)
virtual | ~TLSBase ()
void | setInitLib (bool init)
virtual bool | isSecure () const
virtual const CertInfo & | fetchTLSInfo () const

## Detailed Description

This class implements a TLS client backend using OpenSSL.

Author
  Jakob Schröter js@ca.nosp@m.maya.nosp@m..net

Since
  0.9

Definition at line 35 of file tlsopensslclient.h.

## Constructor & Destructor Documentation

## OpenSSLClient()

OpenSSLClient | ( | TLSHandler * | th,
|  | const std::string & | server )

Constructor.

Parameters

  th | The TLSHandler to handle TLS-related events.
  server | The server to use in certificate verification.

Definition at line 22 of file tlsopensslclient.cpp.

## ~OpenSSLClient()

~OpenSSLClient | ( |  | ) |

virtual

Virtual destructor.

Definition at line 27 of file tlsopensslclient.cpp.

## Member Function Documentation

## channelBinding()

const std::string channelBinding | ( |  | ) | const

virtual

Returns the channel binding data for the established connection.

Returns
  The channel binding data, if any, or the empty string.

Reimplemented from TLSBase.

Definition at line 47 of file tlsopensslclient.cpp.

## channelBindingType()

const std::string channelBindingType | ( |  | ) | const

virtual

Returns the type of channel binding to be used with SCRAM-SHA-1-PLUS.

Returns
  The channel binding type, @default is "tls-unique".

Reimplemented from TLSBase.

Definition at line 65 of file tlsopensslclient.cpp.

## hasChannelBinding()

bool hasChannelBinding | ( |  | ) | const

virtual

This function indicates whether the underlying TLS implementation supports channel binding (used in e.g. SASL SCRAM-SHA-1-PLUS).

Returns
  True if channel binding is supported, false otherwise.

Reimplemented from TLSBase.

Definition at line 42 of file tlsopensslclient.cpp.

The documentation for this class was generated from the following files:

- tlsopensslclient.h
- tlsopensslclient.cpp